// DImputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DImput.h"
#include "DImputDlg.h"
#pragma comment(lib,"dxguid.lib")


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDImputDlg dialog

CDImputDlg::CDImputDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDImputDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDImputDlg)
	m_Edit = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDImputDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDImputDlg)
	DDX_Text(pDX, IDC_EDIT1, m_Edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDImputDlg, CDialog)
	//{{AFX_MSG_MAP(CDImputDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_DESTROY()
	ON_WM_ACTIVATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDImputDlg message handlers

BOOL CDImputDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	g_pDI       = NULL;
	g_pMouse    = NULL;
	HRESULT hr;
	
	hr = DirectInputCreate(AfxGetApp()->m_hInstance   , DIRECTINPUT_VERSION, &g_pDI, NULL );
   if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }


  hr = g_pDI->CreateDevice( GUID_SysMouse, &g_pMouse, NULL );
	if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }

	
	hr=g_pMouse->SetCooperativeLevel(this->m_hWnd,DISCL_FOREGROUND | DISCL_NONEXCLUSIVE);
	
	if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }

	hr=g_pMouse->SetDataFormat(&c_dfDIMouse);

	if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }


	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
		
	// TODO: Add extra initialization here
	
     SetTimer(ID_TIMER_1,1000,NULL);  

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDImputDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDImputDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDImputDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDImputDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
g_pDI->RunControlPanel(this->m_hWnd,0); 
}

void CDImputDlg::OnDestroy() 
{

	HRESULT hr;
	hr=g_pMouse->Unacquire();

		if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }
		g_pMouse->Release();
		g_pDI->Release();
	KillTimer(ID_TIMER_1);
	CDialog::OnDestroy();
	// TODO: Add your message handler code here
	
}

void CDImputDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
	HRESULT hr;
	hr=g_pMouse->Acquire();
	if FAILED(hr) 
   { 
	     ASSERT(FALSE);
   }
	// TODO: Add your message handler code here
	
}

void CDImputDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	HRESULT hr;
	DIMOUSESTATE dims;
	hr = g_pMouse->GetDeviceState( sizeof(DIMOUSESTATE), &dims );
	m_Edit=dims.lX;
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
